<?php
/**
 * @package		
 * @copyright		Copyright (C) 2012 CNPINTEGRATIONS.COM. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die;

abstract class QuickIconHelper
{

	protected static $buttons = array();


	public static function button($button)
	{
		if (!empty($button['access'])) {
			if (is_bool($button['access']) && $button['access'] == false) {
				return '';
			}
			if (!JFactory::getUser()->authorize($button['access'][0], $button['access'][1])) {
				return '';
			}
		}

		ob_start();
		require JModuleHelper::getLayoutPath('mod_adminquickicons', 'default_button');
		$html = ob_get_clean();
		return $html;
	}

	public static function &getButtons( $params )
	{
			$app = JFactory::getApplication();
			self::$buttons = array();

			// Only load the CSS if we are in the backend
			if ($app->isAdmin()) {
	
				$document = JFactory::getDocument();
				$cssfile = $params->get("layouttype", 'icons.css');
				$css = 'modules/mod_adminquickicons/css/' . $cssfile;
				$document->addStyleSheet($css, 'text/css', 'screen');

				// Set the number of modules
				$num_icons = 15;

				// get module's parameters

				for ( $i=1; $i <= $num_icons; $i++ ) {
					$param[$i]['label'] = $params->get("label$i", '');
					$param[$i]['link'] = $params->get("link$i", '');
					$param[$i]['icon'] = $params->get("icon$i", '');
					$param[$i]['custom'] = $params->get("custom$i", '0');
					$param[$i]['path'] = $params->get("path$i", '');
					$param[$i]['c_icon'] = $params->get("c_icon$i", '');
					$param[$i]['order'] = $params->get("order$i", '9');
					// echo 'i= '.$i.' custom= '.$param[$i]['custom'].' path= '.$param[$i]['path'].' icon= '.$param[$i]['c_icon'].'<br />';
				}
						
				jimport ('joomla.filesystem.file'); // Import the file system routines

				$out_index = 0; // Set the output array index
				$template = JFactory::getApplication()->getTemplate();
				
				// Get the Joomla root folder
				$root = JURI::root( true );
				$root = str_replace($root, '/', '');
															
				/// Start ordering the icons according to the order field
				for ($orderval = 0; $orderval < $num_icons; $orderval++ ) {
					// Going to go through the icons looking for ones with the current order value
					for ( $i=1; $i <= $num_icons; $i++ ) {
						// Does this icon have the current order value
						if ($param[$i]['order'] == $orderval) {
							// Check if this icon/link is being used
							if ($param[$i]['link'] != "" && $param[$i]['link'] != 'index.php?option=') {
								// See if there is a custom icon for this link
								//print_r($param[$i]['custom']);echo '</br>';
								if ($param[$i]['custom'] == "1") {//die('TEST');
									// Make sure there is no trailing / on the path
									if ($param[$i]['path'] == '/') {
										$param[$i]['path'] = '';
									} else {
										// there is a path defined, so see if there is a trailing /
										if ( substr($param[$i]['path'], -1) == '/') {
											$param[$i]['path'] = substr($param[$i]['path'], 0, -1);
										}
									}

									$path_adm = JPATH_ADMINISTRATOR;
									$path_adm = str_replace('/','\\',$path_adm);
								
									$file = $path_adm . '\modules\mod_adminquickicons\images\icons\\' . $param[$i]['icon'];
									$path_file = 'administrator/modules/mod_adminquickicons/images/icons';
									
									$param[$i]['icon'] = str_replace('.png','',$param[$i]['icon']);
									$test = explode('-', $param[$i]['icon']);
									self::$buttons[$out_index]['image'] = $test[2];

									if (!JFile::exists ($file)) {
										JError::raiseWarning ( 500, JText::_('KC_FILE_MISSING_ERROR') . $file );
										self::$buttons[$out_index]['image'] = 'icon-48-generic.png';

										self::$buttons[$out_index]['path'] = $root . 'administrator\modules\mod_adminquickicons\images\icons\\';
									} else {
										if ($path_file == '') {
											self::$buttons[$out_index]['path'] = $root . 'administrator\images\\';
										} else {
										
											self::$buttons[$out_index]['path'] = $root . $path_file . '/';
										}

									}
								} else {
									// Not a custom icon, so use the icon the user choose
									
									if (preg_match("/cnp/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'puzzle';
									} elseif (preg_match("/rackspace/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'cog';
									} elseif (preg_match("/login/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'comments-2';
									} elseif (preg_match("/joomla/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'cog';
									} elseif (preg_match("/list/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'list-view';
									} elseif (preg_match("/blog/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'pencil-2';
									} elseif (preg_match("/report/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'comments';
									} elseif (preg_match("/report/i", $param[$i]['label'])) {
										self::$buttons[$out_index]['image'] = 'cog';
									}else {
										self::$buttons[$out_index]['image'] = 'file-add';
									}
									
									//self::$buttons[$out_index]['image'] = 'file-add';
									
									// Default the path to the bluestork template icon path
									self::$buttons[$out_index]['path'] = $root . 'administrator/templates/' . $template . '/images/header/';
								}
								//***
								//self::$buttons['image'] = 'file-add';
								//self::$buttons['link'] = $param[$i]['link'];
								//***
								self::$buttons[$out_index]['text'] =  $param[$i]['label'];
								self::$buttons[$out_index]['link'] =  $param[$i]['link'];
								self::$buttons[$out_index]['target'] =  '_blank';
								//self::$buttons[$out_index]['style'] = 'background-color:red;';
	
								// We need to find the com_ part of the link string to put in the access array
								$startpos = stripos ($param[$i]['link'], 'option=com_');
								if ($startpos !== false ) {
									// found the string so continue to find the end of the component string
									$component = substr ($param[$i]['link'], $startpos + 7);
									// Need to check if there is something after the component name, so look for &
									$endpos = stripos ($component, '&');
									if ($endpos !== false) {
										// we found the &, so need to chop the component string down
										$component = substr ($component, 0, $endpos);
									}
									self::$buttons[$out_index]['access'][0] =  'core.manage';
									self::$buttons[$out_index]['access'][1] = $component;
								}
	
								$out_index++;
							}
						}
					}
				}
			}
		return self::$buttons;
	}
}